var Cus01100_CustoPlanejadoXRealizadoController = function(ScreenService, General, GeneralServices,templateManager) {
	/*global getLocalVar, Configuration, moment*/ 
	var self = this;
	this.setaNomeRelatorio = function(widget) {

		if (!widget.currentRow.CDFILIAL) {
			widget.newRow();
		}
		var 
		PERIODO = widget.getField('PERIODO');
		var defaultValue = {
			start         : getLocalVar('DTPROCESSA'),
			end           : getLocalVar('DTPROCESSA'),
			formattedStart: getLocalVar('DTPROCESSA'),
			formattedEnd  : getLocalVar('DTPROCESSA')
		};
		PERIODO.defaultValue        = defaultValue;
		widget.currentRow.DTINICIAL = getLocalVar('DTPROCESSA');
		widget.currentRow.DTFINAL   = getLocalVar('DTPROCESSA');
		widget.currentRow.NMFILIAL  = getLocalVar('CDFILIAL') + ' | ' + getLocalVar('NMFILIAL');
		widget.currentRow.CDFILIAL  = getLocalVar('CDFILIAL');


		GeneralServices.retornaTipoCustoPadrao(getLocalVar('CDFILIAL')).then(function(callback) {
			if(callback.dataset.defaulttipocusto[0]) {
			    widget.currentRow.CDTIPOCUSTOPLAN  = callback.dataset.defaulttipocusto[0].CDTIPOCUSTO;
			    widget.currentRow.NMTIPOCUSTOPLAN2 = callback.dataset.defaulttipocusto[0].CDTIPOCUSTO;
			    widget.currentRow.NMTIPOCUSTOPLAN  = callback.dataset.defaulttipocusto[0].NMTIPOCUSTO;
			    widget.currentRow.CDTIPOCUSTOREAL  = callback.dataset.defaulttipocusto[0].CDTIPOCUSTO;
			    widget.currentRow.NMTIPOCUSTOREAL2 = callback.dataset.defaulttipocusto[0].CDTIPOCUSTO;
			    widget.currentRow.NMTIPOCUSTOREAL  = callback.dataset.defaulttipocusto[0].NMTIPOCUSTO;
				widget.redraw();
			}
		});
	};
	
	this.onChange = function (field){
		field.widget.currentRow[field.outData[field.valueField]] = field.widget.currentRow[field.name];
		field.widget.currentRow[field.outData[field.descriptionField]] = field.dataSource.data.filter(function(item){
			return item[field.valueField] === field.widget.currentRow[field.name];
		})[0][field.descriptionField];
	};
	
	this.validaData = function(currentRow) {
		
        var dataInicial = currentRow.DTINICIAL ? moment(currentRow.DTINICIAL, 'DD/MM/YYYY')._d : null;
        var dataFinal = currentRow.DTFINAL ? moment(currentRow.DTFINAL, 'DD/MM/YYYY')._d : null;
        var mensagem = "Período inválido";

        if (dataInicial && dataFinal && dataFinal < dataInicial) {
            ScreenService.showMessage(mensagem);
            return false;
        }
        return true;
	};

	this.atualizaListaDeServico = function(widget) {
		var grupoServicos = '';
		var currentRow 	  = widget.currentRow;

		if(currentRow.ALLGRUPSERV == 'N') {
			if (currentRow.NMGRUPSERV.length) {
				grupoServicos = currentRow.NMGRUPSERV.join('_');
			} else {
				grupoServicos = '';
			}
		} else {
			grupoServicos = 'T';
		}
		
		widget.getField("NMSERVICO").dataSourceFilter = [
      {
          name: "CDOPERADOR",
          operator: "=",
          value: getLocalVar("CDOPERADOR")
      },
      {
          "name": "CDFILIAL",
          "operator": "=",
          "value": currentRow.CDFILIAL
      },
      {
          "name": "CDGRUPSERV",
          "operator": "=",
          "value": grupoServicos
      }			
		];
		
		// General.onClickDependentField(widget.getField('NMSERVICO'), {CDFILIAL: currentRow.CDFILIAL, CDGRUPSERV: grupoServicos});
		widget.getField('NMSERVICO').reload();
	};
	
	this.atualizaListaDeServicoConsolidado= function(widget) {
		var grupoServicos = '';
		var currentRow 	  = widget.currentRow;
		var nrOrg = getLocalVar("NRORG");
		
		widget.getField('NMSERVICO2').dataSourceFilter.push(
			{
        name: "NRORG",
        operator: "=",
        value: nrOrg				
			}
		);
		
		if(currentRow.ALLGRUPSERV == 'N') {
			if (currentRow.NMGRUPSERV.length) {
				grupoServicos = currentRow.NMGRUPSERV.join('_');
			} else {
				grupoServicos = '';
			}
		} else {
			grupoServicos = 'T';
		}
		let filterFilial = widget.getField('NMSERVICO2').dataSourceFilter.find(filter=>filter.name == 'CDFILIAL');
		let filterGrupServ = widget.getField('NMSERVICO2').dataSourceFilter.find(filter=>filter.name == 'CDGRUPSERV');
		filterGrupServ.value = '';
		if(widget.getField('ALLGRUPSERV').checked && widget.getField('ALLGRUPSERV').isVisible){
			filterGrupServ.value = 'T';
		} else if(widget.getField('NMGRUPSERV').value() && widget.getField('NMGRUPSERV').value().length){
			filterGrupServ.value = widget.getField('NMGRUPSERV').value().join("_");
		}
		const nmfilial2 = widget.getField('NMFILIAL2'); 
		filterFilial.value = '';
		if(widget.getField('ALLNMFILIAL').checked && widget.getField('ALLNMFILIAL').isVisible){
			filterFilial.value = 'T';
		}else if(nmfilial2.value() && nmfilial2.value().length){
			filterFilial.value = nmfilial2.value().join('_');
		}
		widget.getField('NMSERVICO2').reload();
	};

	this.verificaCheckboxTodos = function(currentRow) {
		if (currentRow.ALLGRUPSERV == 'N' && currentRow.ALLSERVFILI == 'N') {

			currentRow.LISTAGRUPSERV = currentRow.NMGRUPSERV.join('_');
			currentRow.LISTASERV = currentRow.NMSERVICO;

		} else if (currentRow.ALLGRUPSERV == 'S' && currentRow.ALLSERVFILI == 'N') {

			currentRow.LISTAGRUPSERV = 'T';
			currentRow.LISTASERV = currentRow.NMSERVICO;

		} else if (currentRow.ALLGRUPSERV == 'N' && currentRow.ALLSERVFILI == 'S') {

			currentRow.LISTAGRUPSERV = currentRow.NMGRUPSERV.join('_');
			currentRow.LISTASERV = 'T';

		} else if (currentRow.ALLGRUPSERV == 'S' && currentRow.ALLSERVFILI == 'S') {

			currentRow.LISTAGRUPSERV = 'T';
			currentRow.LISTASERV = 'T';
		}
	};

	this.tipoProduto = function(fieldIdEstocaveis, fieldIdNestocaveis) {
		var mensagem = "O tipo de produto não foi informado";

		if(!fieldIdNestocaveis.checked && !fieldIdEstocaveis.checked) {
			ScreenService.showMessage(mensagem);
			return false;
		}
		return true;
	};

	this.validacaoCampos = function(currentRow, fieldIdEstocaveis, fieldIdNestocaveis, widget, args) {
		var reportName = widget.currentRow.REPORT_NAME;

		var reportFormats = [
			{
				name: "pdf",
				value: "PDF"
			},
			{
				name: "xlsx",
				value: "XLSX"
			}
		];

		if (self.validaData(currentRow)) {
			if(self.tipoProduto(fieldIdEstocaveis, fieldIdNestocaveis)) { 
				if(widget.isValid()) {
					General.openReportPopup(widget, self.abreRelatorio, [widget, args, reportName], reportFormats);
				}
			}
		}
	};

	this.abreRelatorio = function(widget, args, reportName) {
		self.verificaCheckboxTodos(widget.currentRow);
		args.row.DTMESINIC = moment(args.row.DTINICIAL, 'DD/MM/YYYY').startOf('month').format('DD/MM/YYYY');
		args.row.DTMESFINA = moment(args.row.DTFINAL, 'DD/MM/YYYY').endOf('month').format('DD/MM/YYYY');
		const allFilial = widget.getField('ALLNMFILIAL');
		const allService = widget.getField('ALLNMSERVICO');
		const allService2 = widget.getField('ALLSERVFILI');
		if(allFilial.checked && allFilial.isVisible){
			args.row.LISTAFILI = 'T';
		} else {
			args.row.LISTAFILI = args.row.CDFILIAL;
			if(reportName == 'CUS01101' || reportName == 'CUS01108' || reportName == 'CUS01107' || reportName == 'CUS01103'){
				args.row.LISTAFILI = widget.currentRow.NMFILIAL2.join('_');
			}
		}
		if((allService.checked && allService.isVisible) || (allService2.checked && allService2.isVisible)){
			args.row.LISTASERV = 'T';
		} else if(widget.getField('NMSERVICO2').isVisible){
			args.row.LISTASERV = widget.getField('NMSERVICO2').value();
		} else {
			args.row.LISTASERV = widget.getField('NMSERVICO').value();
		}
		General.openReport('cus_relatorio#/cus01100_custo_planejado_realizado', reportName, args.row);
	};
	
	
    this.exportDateValues = function(field){
		if(field.value()){
			field.widget.currentRow.DTINICIAL = field.value().start || '';
			field.widget.currentRow.DTFINAL = field.value().end || ''; 
		}
	};
	
	this.changeUnity = function(args){
		var field = args.owner.field;
		var widget = field.widget;
		if(!field.value()){
			widget.currentRow.CDFILIAL = null;
		}
		widget.getField('NMSERVICO').applyDefaultValue();
	};
	this.changeView = function(args){
		var field = args.owner.field;
		var widget = field.widget;
		let reportName = widget.currentRow.REPORT_NAME;
		if(reportName == "CUS01101" || reportName == "CUS01108" || reportName == "CUS01107" || reportName == "CUS01103"){
			widget.getField('NMFILIAL').isVisible = false;
			widget.getField('NMSERVICO').isVisible = false;
			widget.getField('ALLSERVFILI').isVisible = false;
			
			widget.getField('NMGRUPFILI').isVisible = true;
			widget.getField('NMFILIAL2').isVisible = true;
			widget.getField('ALLNMFILIAL').isVisible = true;
			widget.getField('NMSERVICO2').isVisible = true;
			widget.getField('ALLNMSERVICO').isVisible = true;
		}
		else{
			widget.getField('NMFILIAL').isVisible = true;
			widget.getField('NMSERVICO').isVisible = true;
			widget.getField('ALLSERVFILI').isVisible = true;
			
			widget.getField('NMGRUPFILI').isVisible = false;
			widget.getField('NMFILIAL2').isVisible = false;
			widget.getField('ALLNMFILIAL').isVisible = false;
			widget.getField('NMSERVICO2').isVisible = false;
			widget.getField('ALLNMSERVICO').isVisible = false;
		}
		templateManager.updateTemplate();
	};
	this.filtraFiliais = function (widget) {
    let cdgrupfili = 'T';

    widget.getField('NMFILIAL').applyDefaultValue();
		widget.getField('NMSERVICO').applyDefaultValue();
		widget.getField('NMSERVICO').dataSourceFilter = [];
	
    widget.currentRow.CDFILIAL = widget.getField('NMFILIAL').value().substring(0,4);
    
		if (widget.getField('NMGRUPFILI').value()) {
			cdgrupfili = widget.currentRow.CDGRUPFILI;
		} else {
			widget.currentRow.CDGRUPFILI = '';
		}
		
		widget.getField('NMFILIAL2').dataSourceFilter = [
	    {
        name: "CDGRUPFILI",
        operator: "=",
        value: cdgrupfili
	    },
	    {
        name: "CDOPERADOR",
        operator: "=",
        value: "OPERADOR_LOGADO"
	    }
    ];
	    
    widget.getField('NMFILIAL2').clearValue();
		widget.getField('NMFILIAL2').reload();
		self.filtraServicos(widget);
	};

	this.filtraServicos = function (widget) {
		const cdgrupfili = widget.getField('NMGRUPFILI').value() ? widget.currentRow.CDGRUPFILI : "T";
		let cdgrupserv = "";
		let cdfilial = "";
		if(widget.getField('ALLGRUPSERV').checked){
			cdgrupserv = 'T';
		} else if(widget.getField('NMGRUPSERV').value()){
			cdgrupserv = widget.getField('NMGRUPSERV').value().join("_");
		} 
		if(widget.getField('ALLNMFILIAL').checked && widget.getField('ALLNMFILIAL').isVisible){
			cdfilial = 'T';
		} else if(widget.getField('NMFILIAL2').value() && widget.getField('NMFILIAL2').value().length){
			cdfilial = widget.currentRow.NMFILIAL2.join("_");
		}
	    widget.getField('NMSERVICO2').dataSourceFilter = [
            {
                "name": "CDGRUPFILI",
                "operator": "=",
                "value": cdgrupfili
            },
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": cdfilial
            },
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            },
            {
            	"name": "CDGRUPSERV",
            	"operator": "=",
            	"value": cdgrupserv
            }
        ];

		widget.getField('NMSERVICO2').clearValue();
		widget.getField('NMSERVICO2').reload();
	};

	
	
};

Configuration(function(ContextRegister) {
	ContextRegister.register('Cus01100_CustoPlanejadoXRealizadoController', Cus01100_CustoPlanejadoXRealizadoController);
});